OldTakeShape PROC USES ebx esi edi hWnd :DWORD, szBitmap :DWORD ;; Uses white as transparent color!
  ALIGN 4
  LOCAL hdcWindow     :HDC ;; Handle of main window returned from BeginPaint, and automatically released by EndPaint
  LOCAL hdcMask       :HDC ;; Temporary HDC of background bitmap (Also used in the beginning for the mask!)
  LOCAL hbmMask       :HBITMAP ;; Handle to Background bitmap loaded from the resources using LoadBitmap
  LOCAL hrgnFinal     :HRGN
  LOCAL hrgnTemp      :HRGN
  LOCAL bmMask        :BITMAP

  TransColor EQU 00FFFFFFh ;; Color to make Transparent ;; COLORREF == White

  mov hdcWindow, mCall(GetDC, hWnd)
  mov hdcMask, mCall(CreateCompatibleDC, hdcWindow)
  mov hbmMask, mCall(LoadBitmap, App.hInstance, szBitmap)
  INVOKE SelectObject, hdcMask, hbmMask
  INVOKE GetObject, hbmMask, SIZEOF(BITMAP), ADDR bmMask ;; BITMAP pointer MUST be aligned!
  mov hrgnFinal, mCall(CreateRectRgn, 0, 0, 0, 0) ;; final must be initialized before being combined

;    mov TransColor, mCall(GetPixel, hdcBackground, 0, 0) ;; Statically set at design time

  xor edi, edi
  .WHILE (edi < bmMask.bmHeight)
    xor esi, esi
    .WHILE (esi < bmMask.bmWidth)
      .REPEAT
        INVOKE GetPixel, hdcMask, esi, edi ;; 12000 -> 34000 clock cycles
        .BREAK .IF (eax != TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)

      .BREAK .IF (esi == bmMask.bmWidth)

      mov ebx, esi

      .REPEAT
        INVOKE GetPixel, hdcMask, esi, edi
        .BREAK .IF (eax == TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)
      
      mov edx, edi
      inc edx
      mov hrgnTemp, mCall(CreateRectRgn, ebx, edi, esi, edx) ;; 2000 -> 5000 clock cycles

      INVOKE CombineRgn, hrgnFinal, hrgnFinal, hrgnTemp, RGN_OR ;; 20000 -> 70000 clock cycles

      INVOKE DeleteObject, hrgnTemp ;; 800 -> 2100 clock cycles

      inc esi
    .ENDW
    inc edi
  .ENDW

  INVOKE SetWindowRgn, hWnd, hrgnFinal, TRUE

  INVOKE DeleteObject, hrgnFinal
  INVOKE DeleteObject, hbmMask
  INVOKE DeleteDC, hdcMask
  INVOKE ReleaseDC, hWnd, hdcWindow

  ret
OldTakeShape ENDP

NewTakeShape PROC USES ebx esi edi hWnd :DWORD, szBitmap :DWORD ;; Uses white as transparent color!
  ALIGN 4
  LOCAL hdcWindow     :HDC ;; Handle of main window returned from BeginPaint, and automatically released by EndPaint
  LOCAL hdcMask       :HDC ;; Temporary HDC of background bitmap (Also used in the beginning for the mask!)
  LOCAL hbmMask       :HBITMAP ;; Handle to Background bitmap loaded from the resources using LoadBitmap
  LOCAL hrgnFinal     :HRGN
  LOCAL hrgnTemp      :HRGN
  LOCAL bmMask        :BITMAP

  LOCAL tmpBM         :DWORD
  LOCAL rgnHeader     :RGNDATAHEADER
  LOCAL rgnRect       :RECT

  TransColor EQU 00FFFFFFh ;; COLORREF == White

  mov hdcWindow, mCall(GetDC, hWnd)
  mov hdcMask, mCall(CreateCompatibleDC, hdcWindow)
  mov hbmMask, mCall(LoadBitmap, App.hInstance, szBitmap)
  INVOKE SelectObject, hdcMask, hbmMask
  INVOKE GetObject, hbmMask, SIZEOF(BITMAP), ADDR bmMask ;; BITMAP pointer MUST be aligned!
  mov hrgnFinal, mCall(CreateRectRgn, 0, 0, 5, 5) ;; final must be initialized before being combined

;    mov TransColor, mCall(GetPixel, hdcBackground, 0, 0) ;; Statically set at design time

  INVOKE EnterGetPixel, hdcMask
  mov tmpBM, eax

  xor edi, edi
  .WHILE (edi < bmMask.bmHeight)
    xor esi, esi
    .WHILE (esi < bmMask.bmWidth)
      .REPEAT
        INVOKE NewGetPixel, tmpBM, esi, edi
        .BREAK .IF (eax != TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)

      .BREAK .IF (esi == bmMask.bmWidth)

      mov ebx, esi

      .REPEAT
        INVOKE NewGetPixel, tmpBM, esi, edi
        .BREAK .IF (eax == TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)
      
      mov edx, edi
      inc edx
      mov hrgnTemp, mCall(CreateRectRgn, ebx, edi, esi, edx) ;; 2000 -> 5000

      INVOKE CombineRgn, hrgnFinal, hrgnFinal, hrgnTemp, RGN_OR ;; 20000 -> 70000

      INVOKE DeleteObject, hrgnTemp ;; 800 -> 2100

      inc esi
    .ENDW
    inc edi
  .ENDW

  INVOKE ExitGetPixel, tmpBM

  INVOKE SetWindowRgn, hWnd, hrgnFinal, TRUE
  

  INVOKE DeleteObject, hrgnFinal
  INVOKE DeleteObject, hbmMask
  INVOKE DeleteDC, hdcMask
  INVOKE ReleaseDC, hWnd, hdcWindow

  ret
NewTakeShape ENDP


NewRgnTakeShape PROC USES ebx esi edi hWnd :DWORD, szBitmap :DWORD
  ALIGN 4
  LOCAL hdcWindow     :HDC ;; Handle of main window returned from BeginPaint, and automatically released by EndPaint
  LOCAL hdcMask       :HDC ;; Temporary HDC of background bitmap (Also used in the beginning for the mask!)
  LOCAL hbmMask       :HBITMAP ;; Handle to Background bitmap loaded from the resources using LoadBitmap
  LOCAL bmMask        :BITMAP

  LOCAL tmpBM         :DWORD
  LOCAL tmpRGN        :DWORD
  LOCAL tmpRgnLink    :DWORD

  TransColor EQU 00FFFFFFh ;; COLORREF == White

  mov hdcWindow, mCall(GetDC, hWnd)
  mov hdcMask, mCall(CreateCompatibleDC, hdcWindow)
  mov hbmMask, mCall(LoadBitmap, App.hInstance, szBitmap)
  INVOKE SelectObject, hdcMask, hbmMask
  INVOKE GetObject, hbmMask, SIZEOF(BITMAP), ADDR bmMask ;; BITMAP pointer MUST be aligned!

;    mov TransColor, mCall(GetPixel, hdcBackground, 0, 0) ;; Statically set at design time

  INVOKE EnterGetPixel, hdcMask
  mov tmpBM, eax
  INVOKE InitRgnLink
  mov tmpRGN, eax
  mov tmpRgnLink, eax

  xor edi, edi
  .WHILE (edi < bmMask.bmHeight)
    xor esi, esi
    .WHILE (esi < bmMask.bmWidth)
      .REPEAT
        INVOKE NewGetPixel, tmpBM, esi, edi
        .BREAK .IF (eax != TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)

      .BREAK .IF (esi == bmMask.bmWidth)

      mov ebx, esi

      .REPEAT
        INVOKE NewGetPixel, tmpBM, esi, edi
        .BREAK .IF (eax == TransColor)
        inc esi
      .UNTIL (esi == bmMask.bmWidth)

      mov edx, edi
      inc edx
      mov tmpRgnLink, mCall(RgnAdd, tmpRgnLink, ebx, edi, esi, edx) ;; 2000 -> 5000
      inc esi
    .ENDW
    inc edi
  .ENDW

  INVOKE ExitGetPixel, tmpBM

  INVOKE ExitRgnLink, ADDR tmpRGN ;; Returns region counter! Not pointer which is tmpRGN
  INVOKE ExtCreateRegion, NULL, eax, tmpRGN
  INVOKE SetWindowRgn, hWnd, eax, TRUE

  mFree(tmpRGN)

  INVOKE DeleteObject, hbmMask
  INVOKE DeleteDC, hdcMask
  INVOKE ReleaseDC, hWnd, hdcWindow

  ret
NewRgnTakeShape ENDP


RECTEX STRUCT ;; Uni-directional (one-way) linked list of RECT structures
  left DD 0 
  top DD 0 
  right DD 0 
  bottom DD 0 
  pNext DD 0
RECTEX ENDS

InitRgnLink PROC
  mRet mAlloc(SIZEOF(RECTEX))
InitRgnLink ENDP

RgnAdd PROC USES ebx pRECTEX :DWORD, left :DWORD, top :DWORD, right :DWORD, bottom :DWORD ;; Returns new (empty) link!
  mov ebx, pRECTEX
  ASSUME ebx :PTR RECTEX
  .while [ebx].pNext != NULL ;; might not need this! Might be set to the next open link by default! Test this later!
    mov ebx, [ebx].pNext ;; move to next link in linked list
  .endw
  move left, eax, [ebx].left
  move top, eax, [ebx].top
  move right, eax, [ebx].right
  move bottom, eax, [ebx].bottom
  mov [ebx].pNext, mAlloc(SIZEOF(RECTEX))
  ASSUME ebx :NOTHING
  ret
RgnAdd ENDP

ExitRgnLink PROC USES ebx esi edi ppRECTEX :DWORD ;; Returns nCount == the memory size allocated to RGNDATA
  LOCAL pRGNDATA :DWORD
  LOCAL nCount :DWORD ;; Return value == size of data allocated for RGNDATA structure! 

  mov esi, ppRECTEX
  mov esi, [esi]
  ASSUME esi :PTR RECTEX
  xor edi, edi ;; Used as a "rectangle" counter!
  .while [esi].pNext != NULL
    inc edi ;; increment counter
    mov esi, [esi].pNext ;; move to next link in linked list
  .endw
  mov nCount, edi ;; Store the counter to calculate the total RGNDATA memory size, also becomes the return value!
  shl nCount, 4 ;; Multiply by 16 (Size of RECT structure!)
  add nCount, SIZEOF(RGNDATAHEADER)

  mov pRGNDATA, mAlloc(nCount)
  mov ebx, eax ;; For use through subsequent calls to mFree()
  ASSUME ebx :PTR RGNDATAHEADER
  mov [ebx].dwSize, SIZEOF(RGNDATAHEADER)
  mov [ebx].iType, RDH_RECTANGLES
  mov [ebx].nCount, edi
  shl edi, 4 ;; Multiply the above rect counter by 16 = sizeof(RECT)
  mov [ebx].nRgnSize, edi
  ;; Bounds will be re-calculated soon!
  ;; Set them to extreme values to be tested, compared and reset soon!
  mov [ebx].rcBound.left, 0FFFFFFFFH
  mov [ebx].rcBound.top, 0FFFFFFFFH
  mov [ebx].rcBound.right, 0
  mov [ebx].rcBound.bottom, 0

  ASSUME esi :NOTHING
  mov esi, ppRECTEX ;; reset esi to begining of linked list!
  mov esi, [esi]
  ASSUME esi :PTR RECTEX
  mov edi, pRGNDATA ;; could also use eax here! ;; edi is used to receive the new RECT structures!
  add edi, SIZEOF(RGNDATAHEADER) ;; Skip region header, start at the first RECT
  ASSUME edi :PTR RECT
  .while [esi].pNext != NULL
    move [esi].left, ecx, [edi].left
    .if ecx < [ebx].rcBound.left
      mov [ebx].rcBound.left, ecx
    .endif
    move [esi].top, ecx, [edi].top
    .if ecx < [ebx].rcBound.top
      mov [ebx].rcBound.top, ecx
    .endif

    move [esi].right, ecx, [edi].right
    .if ecx > [ebx].rcBound.right
      mov [ebx].rcBound.right, ecx
    .endif
    move [esi].bottom, ecx, [edi].bottom
    .if ecx > [ebx].rcBound.bottom
      mov [ebx].rcBound.bottom, ecx
    .endif

    add edi, SIZEOF(RECT) ;; move to next RECT
    mov ecx, esi ;; Backup pointer
    mov esi, [esi].pNext ;; move to next link in linked list
    mFree(ecx)
  .endw
  mFree(esi)

  ;; NOW using the pointer passed to the PROC, replace the value with the address of the new RGNDATA
  ASSUME esi :NOTHING
  mov esi, ppRECTEX
  mov [esi], ebx ;; ebx still holds pRGNDATA

  ASSUME eax :NOTHING
  ASSUME edi :NOTHING
  mRet nCount
ExitRgnLink ENDP


BITMAPINFOEX STRUCT
  BMI BITMAPINFO <>
  pDIB DD 0 ;; Address of Bitmap bits allocated by CreateDIBSection and later used by GetDIBits
  hBM DD 0 ;; Handle to newly created Bitmap, returned by CreateDIBSection, needs to be freed later!
BITMAPINFOEX ENDS
PBITMAPINFOEX TYPEDEF PTR BITMAPINFOEX

EnterGetPixel PROC USES ebx hDC :DWORD ;; DC with a BMP used to make a replica that NewGetPixel will be called upon!
  LOCAL tmpDC :DWORD ;; A temporary DC compatible with hDC
  LOCAL hBM   :DWORD ;; Handle to the currently selected object in hDC
  LOCAL BM    :BITMAP

  call GetProcessHeap
  INVOKE HeapAlloc, eax, HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY, SIZEOF(BITMAPINFOEX) ;; We need the BITMAPINFO structure in NewGetPixel to get the Height for subtraction
  mov ebx, eax
  ASSUME ebx :PTR BITMAPINFOEX
  
  INVOKE CreateCompatibleDC, hDC
  mov tmpDC, eax

  INVOKE GetCurrentObject, hDC, OBJ_BITMAP
  mov hBM, eax

  INVOKE GetObject, hBM, SIZEOF(BITMAP), ADDR BM
  mov [ebx].BMI.bmiHeader.biSize, SIZEOF(BITMAPINFO)
  m2m [ebx].BMI.bmiHeader.biWidth, BM.bmWidth
  m2m [ebx].BMI.bmiHeader.biHeight, BM.bmHeight
  m2m [ebx].BMI.bmiHeader.biPlanes, BM.bmPlanes ;; Must be set to 1
  m2m [ebx].BMI.bmiHeader.biBitCount, WORD PTR 32 ;BM.bmBitsPixel ;; Should be 32!

  mov [ebx].BMI.bmiHeader.biCompression, BI_RGB
  ;; The remaining structure members are cleared in the call to HeapAlloc
;  mov [ebx].BMI.bmiHeader.biSizeImage, NULL ;; Must be set to 0 for BI_RGB
;  mov [ebx].BMI.bmiHeader.biXPelsPerMeter, NULL
;  mov [ebx].BMI.bmiHeader.biYPelsPerMeter, NULL
;  mov [ebx].BMI.bmiHeader.biClrUsed, NULL
;  mov [ebx].BMI.bmiHeader.biClrImportant, NULL
;  mov [ebx].BMI.bmiColors, 0 ;; No need to clear the RGB colors array, done in call to HeapAlloc!
  INVOKE CreateDIBSection, tmpDC, ADDR [ebx].BMI, DIB_RGB_COLORS, ADDR [ebx].pDIB, NULL, NULL
  mov [ebx].hBM, eax

  INVOKE SelectObject, tmpDC, [ebx].hBM
  INVOKE SelectObject, hDC, eax ;; eax is the return value from the above SelectObject
  ;; Because SelectObject returns the previously held object in the DC, we use the hDC as a temporary storage for
  ;; the old object in tmpDC, we need to remove hBM from hDC because hBM must not be in a DC when we call GetDIBits
  ;; And since we already have the handle to the bitmap in hDC, which is hBM, we don't need to store the return value
  ;; of the second call to SelectObject

  INVOKE GetDIBits, tmpDC, hBM, 0, [ebx].BMI.bmiHeader.biHeight, [ebx].pDIB, ADDR [ebx].BMI, NULL ;; The bitmap identified by the hbmp parameter must not be selected into a device context when the application calls this function.

  INVOKE SelectObject, hDC, hBM
  INVOKE SelectObject, tmpDC, eax ;; eax was the original "stock object" selected into tmpDC

  INVOKE DeleteDC, tmpDC

  ASSUME ebx :NOTHING
  mov eax, ebx
  ret
EnterGetPixel ENDP


NewGetPixel PROC USES ebx hBitmapInfoEx :DWORD, X :DWORD, Y :DWORD
  mov ebx, hBitmapInfoEx
  ASSUME ebx :PTR BITMAPINFOEX

  mov eax, [ebx].BMI.bmiHeader.biHeight
  dec eax ;; Height - 1
  sub eax, Y ;; Height - 1 - Y

  mov ecx, [ebx].BMI.bmiHeader.biWidth
  mul ecx ;; (Height - 1 - Y) * Width

  add eax, X ;; ((Height - 1 - Y) * Width) + X
  shl eax, 2 ;; (((Height - 1 - Y) * Width) + X) * 4

  add eax, [ebx].pDIB ;; Add base address to Offset
  mov eax, [eax]

  ASSUME ebx :NOTHING
  ret
NewGetPixel ENDP


ExitGetPixel PROC hBitmapInfoEx :DWORD
  mov ebx, hBitmapInfoEx
  ASSUME ebx :PTR BITMAPINFOEX
  
  INVOKE DeleteObject, [ebx].hBM

  call GetProcessHeap
  INVOKE HeapFree, eax, NULL, hBitmapInfoEx

  ASSUME ebx :NOTHING
  ret
ExitGetPixel  ENDP
