TopXY PROC wDim :DWORD, sDim :DWORD
  shr   sDim, 1      ; divide screen dimension by 2
  shr   wDim, 1      ; divide window dimension by 2
  mov   eax, wDim    ; copy window dimension into eax
  sub   sDim, eax    ; sub half win dimension from half screen dimension
	mRet sDim
TopXY ENDP

dw2str PROC inVal :DWORD, inAddr :DWORD
  push  ebx
  push  esi
  push  edi

  mov   eax, inVal
  mov   edi, inAddr

  or    eax, eax
  jnz   short @F
  mov   word ptr [edi], 30h
  ret

@@:
  mov   ecx, 429496730
  mov   esi, edi

  .repeat
    mov   ebx, eax
    mul   ecx
    mov   eax, edx
    lea   edx, [edx * 4 + edx]
    add   edx, edx
    sub   ebx, edx
    add   bl, '0'
    mov   [edi], bl
    inc   edi
  .until (eax == 0)

  mov   byte ptr [edi], 0       ; terminate the string

  ; We now have all the digits, but in reverse order.

  .while  (esi < edi)
    dec   edi
    mov   al, [esi]
    mov   ah, [edi]
    mov   [edi], al
    mov   [esi], ah
    inc   esi
  .endw

  pop   edi
  pop   esi
  pop   ebx
  ret
dw2str ENDP

sz2dw proc String:DWORD

  ; ----------------------------------------
  ; Convert decimal string into dword value
  ; return value in eax
  ; ----------------------------------------

    push esi
    push edi

    xor eax, eax
    mov esi, [String]
    xor ecx, ecx
    xor edx, edx
    mov al, [esi]
    inc esi
    cmp al, 2D
    jne proceed
    mov al, byte ptr [esi]
    not edx
    inc esi
    jmp proceed

  @@:
    sub al, 30h
    lea ecx, dword ptr [ecx+4*ecx]
    lea ecx, dword ptr [eax+2*ecx]
    mov al, byte ptr [esi]
    inc esi

  proceed:
    or al, al
    jne @B
    lea eax, dword ptr [edx+ecx]
    xor eax, edx

    pop edi
    pop esi

    ret

sz2dw endp


;=============================================================================
; Copies an image to the face of a Button
;=============================================================================
CopyBitMap  PROC hButt:DWORD, hBmp:DWORD, bWh:DWORD, bHt:DWORD
  LOCAL hMemDC  :DWORD
  LOCAL hDC     :DWORD
  
      INVOKE     GetDC, hButt               ; Get the dc of the button
         mov     hDC, eax
      INVOKE     CreateCompatibleDC, hDC    ; Create a compatible dc in memory
         mov     hMemDC, eax
      INVOKE     SelectObject, hMemDC, hBmp ; Select the opened bitmap into the dc
      INVOKE     BitBlt, hDC, 0, 0, bWh, bHt, hMemDC, 0, 0, SRCCOPY ;Copy the bitmap
      INVOKE     DeleteDC, hMemDC           ; Delete the memory dc
      INVOKE     ReleaseDC, hButt, hDC      ; Release the control dc

         xor    eax, eax
         ret
CopyBitMap  ENDP
